# Algorithmes et structures de données 2020-21

Contenu du cours 2 du du 23.09.2020

*****

## Plus petit commun multiple (PPCM) de deux nombres

-  Algorithme de PPCM: exemple avec 12 et 15

       |  Tester si| `>, <` ou `=`|          |
       |-----------|:------------:|:---------|
       |           | `12 < 15`    |          |
       |           | `24 > 15`    |          |
       |           | `24 < 30`    |          |
       |           | `36 > 30`    |          |
       |           | `36 < 45`    |          |
       |           | `48 > 45`    |          |
       |           | `48 < 60`    |          |
       |           | `60 = 60`    | **Fin !**|
   

## Plus grand diviseur commun (PGCD) de deux nombres

-   Algorithme naïf du PGCD
    -   Pseudo-code du calcul du `PGCD` de `N` et `M`

```
            si M rem N = 0 alors
                PGCD := N
            sinon
                pour I de sqrt(N) à 1 faire
                    si N rem I = 0 et M rem I = 0 alors
                        PGCD := I
                        exit
                    fin si
                fin pour
            fin si
```

- Algorithme d'Euclide : exemple avec N = 35 et M = 60
 
    | Dividende  |  =   | Diviseur \* Quotient  |  +  |  Reste  |
    |:----------:|:----:|:---------------------:|:---:|:-------:|
    |     35     |  =   |   60 \* 0             |  +  |   35    |
    |     60     |  =   |   35 \* 1             |  +  |   25    |
    |     35     |  =   |   25 \* 1             |  +  |   10    |
    |     25     |  =   |   10 \* 2             |  +  |    5    |
    |     10     |  =   |    5 \* 2             |  +  |    0    |
      
> >     => PGCD = 5


## Exercice : Montrer que `PGCD(M,N)*PPCM(M,N) = M*N` 

- Utiliser la décomposition en facteurs 1<sup>er<sup/>

## Type composé : tableaux statiques à une dimension

-   Collection ordonnée d'objets de même type dont le nombre est connu à la compilation
-   La taille d'un tableau statique ne peut pas changer en cours d'exécution
-   Allocation contiguë en mémoire et sur la pile

```C
        int entiers[] = {1,2,3,4,5};
        int tab[3];
```
- Accès aux éléments d’un tableau via l’opérateur `[index]` où `index` est l’indice de l’élément à accéder, `index` va de 0 à la taille du tableau moins un
```C
        int premier = entiers[0];
        int dernier = entiers[4];
```
> **Attention!** L'accès à un indice hors de l'intervalle zéro à la taille du tableau moins un ne produit pas d'erreur à la compilation, mais possible à l'exécution.

-   Tableau de nombres flottants
```C
        const int SIZE = 13;
        float tab[SIZE];
```

-   Initialisation d'un tableau de floats avec `i*i`, puis avec des nombres aléatoires
```C
        for (int i=0;i<SIZE;i++) {
            tab[i] = (float)rand()/(float)(RAND_MAX) ;
        }
```
-   Recherche d'un indice de la valeur minimale d'un tableau de floats et permutation avec l'élément en 1<sup>ère</sup> position
-   Répétition de l'opération précédente sur des tranches du tableau
-   Tri par sélection avec illustration sur un exemple
-   Algorithme de vérification que deux mots sont des anagrammes en utilisant un tri

